#!/bin/bash

sudo apt install -y nlohmann-json3-dev wget curl cmake ninja-build mold

if [ ! -f /usr/local/lib/libassert.a ]; then
    git clone https://github.com/jeremy-rifkin/libassert.git
    git checkout v2.1.5
    mkdir libassert/build
    cd libassert/build
    cmake .. -DCMAKE_BUILD_TYPE=Release
    make -j
    sudo make install
    cd ../..
    rm -rf libassert
fi

if [ ! -f /usr/local/include/httplib.h ]; then
    sudo wget -q https://raw.githubusercontent.com/yhirose/cpp-httplib/master/httplib.h \
        -O /usr/local/include/httplib.h
fi


# install zig
if [ ! -f ${HOME}/.local/bin/zig ]; then
    mkdir -p temp
    rm -rf ${HOME}/.zig
    mkdir -p ${HOME}/.zig
    wget https://ziglang.org/builds/zig-x86_64-linux-0.15.0-dev.643+dc6ffc28b.tar.xz -O temp/zig.tar.xz
    tar -xf temp/zig.tar.xz -C temp
    mv temp/zig-x86_64-linux-0.15.0-dev.643+dc6ffc28b/zig ${HOME}/.zig/zig
    mv temp/zig-x86_64-linux-0.15.0-dev.643+dc6ffc28b/lib ${HOME}/.zig/
    ln -s ${HOME}/.zig/zig ${HOME}/.local/bin/zig
    rm -rf temp
    zig version
fi

